# random-forest-substrate

__Main author:__  Cole Fields  
__Affiliation:__  Fisheries and Oceans Canada (DFO)   
__Group:__        Marine Spatial Ecology and Analysis   
__Location:__     Institute of Ocean Sciences   
__Contact:__      e-mail: Cole.Fields@dfo-mpo.gc.ca | tel: 250-363-8060


- [Objective](#objective)
- [Summary](#summary)
- [Status](#status)
- [Contents](#contents)
  + [Fit Random Forest](#fit-random-forest)
  + [Run Plots](#run-plots)
  + [Plot Functions](#plot-functions)
  + [Figures](#figures)
- [Methods](#methods)
  + [Fit Random Forest](#fit-random-forest)
  + [Run Plots](#run-plots)
  + [Updates](#updates)
- [Requirements](#requirements)
- [Caveats](#caveats)
- [Uncertainty](#uncertainty)
- [Acknowledgements](#acknowledgements)
- [References](#references)


## Objective
The objective of this code is to produce substrate models and report on their
performance metrics from a withheld subset of observation data.


## Summary
Generates a model predicting substrate class (rock, mixed, sand, or mud) using 
random forest and a stack of environmental predictors. Model is tested against 
withheld testing observations. Model can be run using a 1-step or 2-step 
approach. The 2-step approach generates a binary rock/not-rock layer and a 
mixed/sand/mud layer and the two are combined. This approach was created to 
reduce the prevalence of predicted rock in the output raster. Substrate index 
layers (densities per class) can also be produced. Observations include data
from ROV surveys, CHS observations, and NRCan core samples.


## Status
Completed


## Contents
### Fit Random Forest
Generates a model predicting substrate class (rock, mixed, sand, or mud) using 
random forest and a stack of environmental predictors.

### Run Plots
Run_Plots.R creates 3 figures. One figure shows the proportion of observations 
by class with the proportion of predicted substrate by class for all regions 
(five 20m regions and one 100m region) by method (one-step and two-step). 
The user must enter the paths to the observation files and the substrates.
Figures of Kappa and Accuracy performance by depth bin and method are produced. 
The user must provide the paths to the observation files and the predicted 
rasters.

### Plot Functions
Plot_Functions.R has the functions to create the figures that are run in 
Run_Plots.R.

### Figures
figures.Rmd outputs a HTML file including the figures generated by Run-Plots.R 
and captions. Could modify to output PDF format.


## Methods
### Fit Random Forest
* Loads observation points from a feature class.
* Creates a raster stack from the predictor layer directory.
* Attaches the predictor values to observation points.
* Removes invalid observations (missing BType4 values or predictor values).
* Makes data summary table (xlsx file).
* Splits data into 'training' and 'test' sets.
* Fits Random Forest model using training data (done once for 1-step, and 
twice for 2-step (binary Rock model and Mixed-Sand-Mud model).
* If running 2-step, combine Rock and Mixed-Sand-Mud (rock overwrites msm model)
models.
* Writes R model files and predicted rasters (TIFF format) to output directories
in Albers projection.
* Creates evaluation statistics from test data and predicted rasters.
* Writes log text file with information on observations and predicted rasters
(such as proportion of each class from obs and predicted).

### Run Plots
* Calls a series of funcitons from plot_functions.R to create plots and figures.
* Figures include performance metrics by class and depth and method (1 vs 2
step ).
* Creates figures.RMD which is an R markdown file that combines the plots
and figures into one file that can be viewed in a browser.

### Updates

October, 2018

* Strip most attributes from observation data (keeps BType4, BT_Source, 
TestData, and Rock [if running two-step])
* Attaches predictor variables from rasters to spatial points data frame
* Produces a 2-step model (binary rock combined with mixed-sand-mud) and a 
single-step model

December, 2018

* Outputs obs folder and shapefile that has the observations used in the model 
(points that overlay raster stack and have no NA values)
* Generates an excel summary table with number of observations by class and 
source used in final model

February 2019
* Changed logic for executing 1-step and 2-step code
* boolean variables for running one-step and/or two-step
* generates list of raster predictor names that are used as part of the 
random forest formula
* checks if required packages are installed and installs if they are not


## Requirements
### Parameters for Fit Random Forest:
* observations.database: path to file geodatabase that has the observation 
points 
feature class
* feature.class: name of observation points feature class
* output.directory: path for output directory (will create if doesn't exist)
* predictors.directory: filepath to predictor directory (rasters must be tif 
format)
* one.step: run one-step process? TRUE/FALSE
* two.step: run two-step process? create binary rock, and mixed-sand-mud model 
and combine them. TRUE/FALSE. Running only two-step will mean that the script 
will not output predictor importance plots
* density.layers: create substrate density layers (sum of cells for each 
substrate with a 10 cell neighbourhood)? TRUE/FALSE
* dat.res: resolution of cells in predictor raster stack (e.g. 20, 50, 100)


## Caveats
* Observation points must be a feature class inside a file geodatabase
* Observations must have these fields: BType4, BT_Source, TestData, Rock 
(if running two-step)
* TestData must already be assigned (0s and 1s)
* If running 2-step, the binary rock raster is a probability (or rock) surface. 
The optimal threshold for classifying into Rock or Not Rock is determined by 
finding the value that maximizes Kappa.
* Evaluation statistics from 2-step process are somewhat misleading because test
rock records are used for determining the threshold for classifying rock into 
binary by maximizing Kappa - known problem that has been brought to the 
attention of group


## Uncertainty
* multiple levels of uncertainty
* how observations were mapped from original substrate classification from
multiple sources to a common classification scheme
* uncertainty in predictor layers (models and derivatives from models)
* notably uncertainty in mixed classification


## Acknowledgements
* Jessica Nephin
* Kim Conway
* Robert Kung
* Ed Gregr
* Joanne Lessard
* Sarah Davies
* Dana Haggarty


## References
NA
